'Copyright (c) 2005-2012 Donald Milne
'All rights reserved.
'
'This file is part of implantHelper.
'
'implantHelper is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'Foobar is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with implantHelper.  If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.Drawing
Imports System.Collections
Imports System.Windows.Forms
Imports Microsoft.VisualBasic

Public Class ihControl1 : Inherits UserControl

    Private prvItemIdx As Integer = -1
    Private prvTabPage As TabPage
    Private prvToolTip As ToolTip
    Private prvHandler As EventHandler

    Private prvQL As Integer = 1
    Private prvProfID As Integer = 0

    Private useHandler As Boolean = False

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    Friend WithEvents lblType As System.Windows.Forms.Label
    Friend WithEvents cmbShiny As System.Windows.Forms.ComboBox
    Friend WithEvents cmbBright As System.Windows.Forms.ComboBox
    Friend WithEvents cmbFaded As System.Windows.Forms.ComboBox
    Friend WithEvents cmbSymbSpirit As System.Windows.Forms.ComboBox
    Friend WithEvents lblQL As System.Windows.Forms.Label
    Friend WithEvents nudQL As System.Windows.Forms.NumericUpDown
    Friend WithEvents ttHover As System.Windows.Forms.ToolTip
    Friend WithEvents lblAttrib As System.Windows.Forms.Label
    Friend WithEvents lblAlienEye As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.lblType = New System.Windows.Forms.Label()
        Me.cmbShiny = New System.Windows.Forms.ComboBox()
        Me.cmbBright = New System.Windows.Forms.ComboBox()
        Me.cmbFaded = New System.Windows.Forms.ComboBox()
        Me.nudQL = New System.Windows.Forms.NumericUpDown()
        Me.cmbSymbSpirit = New System.Windows.Forms.ComboBox()
        Me.lblQL = New System.Windows.Forms.Label()
        Me.ttHover = New System.Windows.Forms.ToolTip(Me.components)
        Me.lblAttrib = New System.Windows.Forms.Label()
        Me.lblAlienEye = New System.Windows.Forms.Label()
        CType(Me.nudQL, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'lblType
        '
        Me.lblType.BackColor = System.Drawing.Color.LightSeaGreen
        Me.lblType.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblType.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblType.Location = New System.Drawing.Point(0, 0)
        Me.lblType.Name = "lblType"
        Me.lblType.Size = New System.Drawing.Size(24, 24)
        Me.lblType.TabIndex = 0
        Me.lblType.Text = "I"
        Me.lblType.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'cmbShiny
        '
        Me.cmbShiny.Anchor = System.Windows.Forms.AnchorStyles.Top
        Me.cmbShiny.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbShiny.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmbShiny.ForeColor = System.Drawing.SystemColors.WindowText
        Me.cmbShiny.Location = New System.Drawing.Point(32, 0)
        Me.cmbShiny.MaxDropDownItems = 24
        Me.cmbShiny.Name = "cmbShiny"
        Me.cmbShiny.Size = New System.Drawing.Size(184, 24)
        Me.cmbShiny.TabIndex = 1
        '
        'cmbBright
        '
        Me.cmbBright.Anchor = System.Windows.Forms.AnchorStyles.Top
        Me.cmbBright.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbBright.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmbBright.ForeColor = System.Drawing.SystemColors.WindowText
        Me.cmbBright.Location = New System.Drawing.Point(216, 0)
        Me.cmbBright.MaxDropDownItems = 24
        Me.cmbBright.Name = "cmbBright"
        Me.cmbBright.Size = New System.Drawing.Size(184, 24)
        Me.cmbBright.TabIndex = 2
        '
        'cmbFaded
        '
        Me.cmbFaded.Anchor = System.Windows.Forms.AnchorStyles.Top
        Me.cmbFaded.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbFaded.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmbFaded.ForeColor = System.Drawing.SystemColors.WindowText
        Me.cmbFaded.Location = New System.Drawing.Point(400, 0)
        Me.cmbFaded.MaxDropDownItems = 24
        Me.cmbFaded.Name = "cmbFaded"
        Me.cmbFaded.Size = New System.Drawing.Size(184, 24)
        Me.cmbFaded.TabIndex = 3
        '
        'nudQL
        '
        Me.nudQL.Anchor = System.Windows.Forms.AnchorStyles.Top
        Me.nudQL.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.nudQL.Location = New System.Drawing.Point(584, 0)
        Me.nudQL.Maximum = New Decimal(New Integer() {300, 0, 0, 0})
        Me.nudQL.Minimum = New Decimal(New Integer() {1, 0, 0, 0})
        Me.nudQL.Name = "nudQL"
        Me.nudQL.Size = New System.Drawing.Size(48, 22)
        Me.nudQL.TabIndex = 4
        Me.nudQL.Value = New Decimal(New Integer() {1, 0, 0, 0})
        '
        'cmbSymbSpirit
        '
        Me.cmbSymbSpirit.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbSymbSpirit.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmbSymbSpirit.ForeColor = System.Drawing.SystemColors.WindowText
        Me.cmbSymbSpirit.Location = New System.Drawing.Point(32, 24)
        Me.cmbSymbSpirit.MaxDropDownItems = 24
        Me.cmbSymbSpirit.Name = "cmbSymbSpirit"
        Me.cmbSymbSpirit.Size = New System.Drawing.Size(552, 24)
        Me.cmbSymbSpirit.TabIndex = 5
        Me.cmbSymbSpirit.Visible = False
        '
        'lblQL
        '
        Me.lblQL.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lblQL.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblQL.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblQL.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.lblQL.Location = New System.Drawing.Point(584, 24)
        Me.lblQL.Name = "lblQL"
        Me.lblQL.Size = New System.Drawing.Size(48, 24)
        Me.lblQL.TabIndex = 6
        Me.lblQL.Text = "1"
        Me.lblQL.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.lblQL.Visible = False
        '
        'lblAttrib
        '
        Me.lblAttrib.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lblAttrib.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblAttrib.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblAttrib.Location = New System.Drawing.Point(640, 0)
        Me.lblAttrib.Name = "lblAttrib"
        Me.lblAttrib.Size = New System.Drawing.Size(40, 24)
        Me.lblAttrib.TabIndex = 7
        Me.lblAttrib.Text = "None"
        Me.lblAttrib.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblAlienEye
        '
        Me.lblAlienEye.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblAlienEye.Font = New System.Drawing.Font("Arial", 10.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblAlienEye.Location = New System.Drawing.Point(32, 48)
        Me.lblAlienEye.Name = "lblAlienEye"
        Me.lblAlienEye.Size = New System.Drawing.Size(552, 23)
        Me.lblAlienEye.TabIndex = 8
        Me.lblAlienEye.Text = "Exterminator Occular Enhancment"
        Me.lblAlienEye.Visible = False
        '
        'ihControl1
        '
        Me.Controls.Add(Me.lblAlienEye)
        Me.Controls.Add(Me.lblAttrib)
        Me.Controls.Add(Me.lblQL)
        Me.Controls.Add(Me.cmbSymbSpirit)
        Me.Controls.Add(Me.nudQL)
        Me.Controls.Add(Me.cmbFaded)
        Me.Controls.Add(Me.cmbBright)
        Me.Controls.Add(Me.cmbShiny)
        Me.Controls.Add(Me.lblType)
        Me.Name = "ihControl1"
        Me.Size = New System.Drawing.Size(680, 72)
        CType(Me.nudQL, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Public Property ItemIdx() As Integer
        Get
            Return prvItemIdx
        End Get
        Set(ByVal Value As Integer)
            prvItemIdx = Value
        End Set
    End Property

    Public Property QL() As Integer
        Get
            Return prvQL
        End Get
        Set(ByVal Value As Integer)
            prvQL = Value
            Me.nudQL.Value = Value
        End Set
    End Property

    Public Property ProfessionID() As Integer
        Get
            Return prvProfID
        End Get
        Set(ByVal Value As Integer)
            prvProfID = Value
            setSymbsAndSpirits()
            If Value = SHADE_ID Then
                If Me.lblType.Text = "I" Then
                    changeLabel()
                End If
            End If
        End Set
    End Property

    Public ReadOnly Property ShinyCluster() As String
        Get
            If Me.cmbShiny.SelectedIndex <> -1 Then
                Return Me.cmbShiny.Items(Me.cmbShiny.SelectedIndex)
            Else
                Return SEL_STRING
            End If
        End Get
    End Property

    Public ReadOnly Property BrightCluster() As String
        Get
            If Me.cmbBright.SelectedIndex <> -1 Then
                Return Me.cmbBright.Items(Me.cmbBright.SelectedIndex)
            Else
                Return SEL_STRING
            End If
        End Get
    End Property

    Public ReadOnly Property FadedCluster() As String
        Get
            If Me.cmbFaded.SelectedIndex <> -1 Then
                Return Me.cmbFaded.Items(Me.cmbFaded.SelectedIndex)
            Else
                Return SEL_STRING
            End If
        End Get
    End Property

    Public ReadOnly Property SymbiantOrSpirit() As String
        Get
            Return Me.cmbSymbSpirit.Items(Me.cmbSymbSpirit.SelectedIndex)
        End Get
    End Property

    Public ReadOnly Property SorI() As String
        Get
            Return Me.lblType.Text
        End Get
    End Property

    Public ReadOnly Property FadedClusterBonus() As Integer
        Get
            Return getClusterBonus(1, Me.cmbFaded.Items(Me.cmbFaded.SelectedIndex), prvQL)
        End Get
    End Property

    Public ReadOnly Property BrightClusterBonus() As Integer
        Get
            Return getClusterBonus(2, Me.cmbBright.Items(Me.cmbBright.SelectedIndex), prvQL)
        End Get
    End Property

    Public ReadOnly Property ShinyClusterBonus() As Integer
        Get
            Return getClusterBonus(3, Me.cmbShiny.Items(Me.cmbShiny.SelectedIndex), prvQL)
        End Get
    End Property

    Public ReadOnly Property SymbSpiritBonuses() As String
        Get
            Return getSymbiantAndSpiritBonuses(Me.cmbSymbSpirit.Items(Me.cmbSymbSpirit.SelectedIndex))
        End Get
    End Property

    Public ReadOnly Property Requisites() As String
        Get
            If Me.lblType.Text = "I" Then
                Return getImplantReqs(Me.cmbShiny.Items(Me.cmbShiny.SelectedIndex), Me.cmbBright.Items(Me.cmbBright.SelectedIndex), Me.cmbFaded.Items(Me.cmbFaded.SelectedIndex), prvQL)
            ElseIf Me.lblType.Text = "A" Then
                Return getAlienEyeRequisites(Me.prvQL)
            Else
                Return getSymbOrSpiritReqs(Me.cmbSymbSpirit.Items(Me.cmbSymbSpirit.SelectedIndex))
            End If
        End Get
    End Property

    Public ReadOnly Property NPRequisites() As Integer
        Get
            If Me.lblType.Text = "I" Then
                Return getImplantNPReqs(Me.cmbShiny.Items(Me.cmbShiny.SelectedIndex), Me.cmbBright.Items(Me.cmbBright.SelectedIndex), Me.cmbFaded.Items(Me.cmbFaded.SelectedIndex), prvQL)
            Else
                Return -1
            End If
        End Get
    End Property

    Public Property ControlTabPage() As TabPage
        Get
            Return prvTabPage
        End Get
        Set(ByVal Value As TabPage)
            prvTabPage = Value
        End Set
    End Property

    Public Property ChangeHandler() As EventHandler
        Get
            Return prvHandler
        End Get
        Set(ByVal Value As EventHandler)
            prvHandler = Value
            useHandler = True
        End Set
    End Property

    Public Sub loadClusters()
        Dim res As String
        Dim resA1() As String
        Dim resA2() As String
        Dim resA3() As String

        res = getClustersBySlotAndBSF(prvItemIdx, 3)
        resA3 = res.Split("#")
        Me.cmbShiny.Items.Clear()
        Me.cmbShiny.Items.Add(SEL_STRING)
        For i As Integer = 0 To resA3.Length - 1
            Me.cmbShiny.Items.Add(resA3(i))
        Next
        Me.cmbShiny.SelectedIndex = 0
        res = getClustersBySlotAndBSF(prvItemIdx, 2)
        resA2 = res.Split("#")
        Me.cmbBright.Items.Clear()
        Me.cmbBright.Items.Add(SEL_STRING)
        For i As Integer = 0 To resA2.Length - 1
            Me.cmbBright.Items.Add(resA2(i))
        Next
        Me.cmbBright.SelectedIndex = 0
        res = getClustersBySlotAndBSF(prvItemIdx, 1)
        resA1 = res.Split("#")
        Me.cmbFaded.Items.Clear()
        Me.cmbFaded.Items.Add(SEL_STRING)
        For i As Integer = 0 To resA1.Length - 1
            Me.cmbFaded.Items.Add(resA1(i))
        Next
        Me.cmbFaded.SelectedIndex = 0
    End Sub

    Public Sub setSymbsAndSpirits()
        Dim res As String
        Dim resA() As String

        If prvProfID = 0 Then
            Return
        End If
        res = getSymbsAndSpiritsBySlotAndProf(prvItemIdx, prvProfID)
        resA = res.Split("#")
        Me.cmbSymbSpirit.Items.Clear()
        Me.cmbSymbSpirit.Items.Add(SEL_STRING)
        For i As Integer = 0 To resA.Length - 1
            Me.cmbSymbSpirit.Items.Add(resA(i))
        Next
        Me.cmbSymbSpirit.SelectedIndex = 0
    End Sub

    Public Sub highlightSpecified(ByVal cluster As String)
        If Me.cmbFaded.Items.Contains(cluster) Then
            Me.cmbFaded.BackColor = Color.FromName("LightGreen")
        Else
            Me.cmbFaded.BackColor = Color.FromName("Window")
        End If
        If Me.cmbBright.Items.Contains(cluster) Then
            Me.cmbBright.BackColor = Color.FromName("LightGreen")
        Else
            Me.cmbBright.BackColor = Color.FromName("Window")
        End If
        If Me.cmbShiny.Items.Contains(cluster) Then
            Me.cmbShiny.BackColor = Color.FromName("LightGreen")
        Else
            Me.cmbShiny.BackColor = Color.FromName("Window")
        End If
    End Sub

    Public Sub filterSpecified(ByVal cluster As String)
        Dim res As String
        Dim current_symbiant As String
        Dim use_filter As Boolean = False

        ' store current symbiant first, then recover it in list after
        If Me.cmbSymbSpirit.SelectedIndex = -1 Then
            current_symbiant = SEL_STRING
        Else
            current_symbiant = Me.cmbSymbSpirit.Items(Me.cmbSymbSpirit.SelectedIndex)
        End If
        If cluster = FIND_SEL_STRING Then
            res = getSymbsAndSpiritsBySlotAndProf(prvItemIdx, prvProfID)
        Else
            res = getFilteredSymbsAndSpiritsBySlotAndProf(current_symbiant, cluster, prvItemIdx, prvProfID)
            use_filter = True
        End If
        processFilter(res, current_symbiant)
        If use_filter And Me.cmbSymbSpirit.Items.Count > 1 Then
            Me.cmbSymbSpirit.BackColor = Color.FromName("LightGreen")
        Else
            Me.cmbSymbSpirit.BackColor = Color.FromName("Window")
            res = getSymbsAndSpiritsBySlotAndProf(prvItemIdx, prvProfID)
            res = SEL_STRING & "#" & res
            If res.EndsWith("#") Then
                res = res.Substring(0, res.Length - 1)
            End If
            processFilter(res, current_symbiant)
        End If
    End Sub

    Private Sub processFilter(ByVal res As String, ByVal current_symbiant As String)
        Dim resA() As String

        resA = res.Split("#")
        Me.cmbSymbSpirit.Items.Clear()
        If current_symbiant <> SEL_STRING Then
            Me.cmbSymbSpirit.Items.Add(SEL_STRING)
        End If
        For i As Integer = 0 To resA.Length - 1
            Me.cmbSymbSpirit.Items.Add(resA(i))
        Next
        For i As Integer = 0 To Me.cmbSymbSpirit.Items.Count - 1
            If Me.cmbSymbSpirit.Items(i) = current_symbiant Then
                Me.cmbSymbSpirit.SelectedIndex = i
                Exit For
            End If
        Next
    End Sub

    Public Sub changeSpecified(ByVal cluster As String)
        If Me.cmbFaded.Items.Contains(cluster) And Me.cmbFaded.SelectedIndex = 0 Then
            setElement("Faded", cluster)
        End If
        Me.cmbFaded.BackColor = Color.FromName("Window")
        If Me.cmbBright.Items.Contains(cluster) And Me.cmbBright.SelectedIndex = 0 Then
            setElement("Bright", cluster)
        End If
        Me.cmbBright.BackColor = Color.FromName("Window")
        If Me.cmbShiny.Items.Contains(cluster) And Me.cmbShiny.SelectedIndex = 0 Then
            setElement("Shiny", cluster)
        End If
        Me.cmbShiny.BackColor = Color.FromName("Window")
    End Sub

    Public Sub setFocus(ByVal sbf As String)
        Me.Focus()
        If sbf = "Shiny" Then
            Me.cmbShiny.Focus()
        ElseIf sbf = "Bright" Then
            Me.cmbBright.Focus()
        ElseIf sbf = "Faded" Then
            Me.cmbFaded.Focus()
        End If
    End Sub

    Public Sub setElement(ByVal sbf As String, ByVal n As String)
        Dim oldUseHandler As Boolean

        oldUseHandler = useHandler
        useHandler = False
        If sbf = "Shiny" Then
            If Me.lblType.Text = "S" Then
                changeLabel()
            End If
            If Me.cmbShiny.Items.Contains(n) Then
                Me.cmbShiny.SelectedIndex = Me.cmbShiny.Items.IndexOf(n)
            Else
                Me.cmbShiny.SelectedIndex = 0
            End If
        ElseIf sbf = "Bright" Then
            If Me.lblType.Text = "S" Then
                changeLabel()
            End If
            If Me.cmbBright.Items.Contains(n) Then
                Me.cmbBright.SelectedIndex = Me.cmbBright.Items.IndexOf(n)
            Else
                Me.cmbBright.SelectedIndex = 0
            End If
        ElseIf sbf = "Faded" Then
            If Me.cmbFaded.Items.Contains(n) Then
                If Me.lblType.Text = "S" Then
                    changeLabel()
                End If
                Me.cmbFaded.SelectedIndex = Me.cmbFaded.Items.IndexOf(n)
            Else
                Me.cmbFaded.SelectedIndex = 0
            End If
        ElseIf sbf = "EOE" Then ' Exterminator Occular Enhancement
            If Me.lblType.Text = "I" Then
                changeLabel()
                changeLabel()
            ElseIf Me.lblType.Text = "S" Then
                changeLabel()
            End If
        Else
            If Me.lblType.Text = "I" Then
                changeLabel()
            End If
            If Me.cmbSymbSpirit.Items.Contains(n) Then
                Me.cmbSymbSpirit.SelectedIndex = Me.cmbSymbSpirit.Items.IndexOf(n)
            Else
                Me.cmbSymbSpirit.SelectedIndex = 0
            End If
        End If
        useHandler = oldUseHandler
        If useHandler Then
            prvHandler(Me, Nothing)
        End If
    End Sub

    Public Function getElement(ByVal sbf As String) As String
        If sbf = "Shiny" Then
            Return Me.ShinyCluster
        ElseIf sbf = "Bright" Then
            Return Me.BrightCluster
        ElseIf sbf = "Faded" Then
            Return Me.FadedCluster
        Else
            Return "ERROR"
        End If
    End Function

    Public Sub resetAll()
        Dim oldUseHandler As Boolean

        oldUseHandler = useHandler
        useHandler = False
        If Me.lblType.Text = "S" Then
            changeLabel()
        End If
        If Me.lblType.Text = "A" Then
            changeLabel()
        End If
        Me.QL = 1
        Me.cmbFaded.SelectedIndex = 0
        Me.cmbBright.SelectedIndex = 0
        Me.cmbShiny.SelectedIndex = 0
        Me.ProfessionID = 0
        updateTT()
        useHandler = oldUseHandler
        If useHandler Then
            prvHandler(Me, Nothing)
        End If
    End Sub

    Private Sub changeLabel()
        If Me.lblType.Text = "I" Then
            If prvProfID = 0 Then
                Return
            End If
            Me.lblType.Text = "S"
            Me.lblType.BackColor = System.Drawing.Color.OliveDrab
            Me.cmbSymbSpirit.Visible = True
            Me.lblAlienEye.Visible = False
            Me.lblQL.Visible = True
            Me.cmbFaded.Visible = False
            Me.cmbBright.Visible = False
            Me.cmbShiny.Visible = False
            Me.nudQL.Visible = False
            Me.lblAttrib.Visible = False
            If useHandler Then
                prvHandler(Me, Nothing)
            End If
        ElseIf Me.lblType.Text = "S" Then
            If prvItemIdx = 0 And checkProfAlienEye(prvProfID) Then
                Me.lblType.Text = "A"
                Me.lblType.BackColor = System.Drawing.Color.GreenYellow
                Me.cmbSymbSpirit.Visible = False
                Me.lblAlienEye.Visible = True
                Me.lblQL.Visible = False
                Me.cmbFaded.Visible = False
                Me.cmbBright.Visible = False
                Me.cmbShiny.Visible = False
                Me.nudQL.Visible = True
                Me.lblAttrib.Visible = False
                If useHandler Then
                    prvHandler(Me, Nothing)
                End If
                ' update tooltip here
                Me.updateTT()
            Else
                Me.lblType.Text = "I"
                Me.lblType.BackColor = System.Drawing.Color.LightSeaGreen
                Me.cmbSymbSpirit.Visible = False
                Me.lblAlienEye.Visible = False
                Me.lblQL.Visible = False
                Me.cmbFaded.Visible = True
                Me.cmbBright.Visible = True
                Me.cmbShiny.Visible = True
                Me.nudQL.Visible = True
                Me.lblAttrib.Visible = True
                If useHandler Then
                    prvHandler(Me, Nothing)
                End If
            End If
        Else
            Me.lblType.Text = "I"
            Me.lblType.BackColor = System.Drawing.Color.LightSeaGreen
            Me.cmbSymbSpirit.Visible = False
            Me.lblAlienEye.Visible = False
            Me.lblQL.Visible = False
            Me.cmbFaded.Visible = True
            Me.cmbBright.Visible = True
            Me.cmbShiny.Visible = True
            Me.nudQL.Visible = True
            Me.lblAttrib.Visible = True
            If useHandler Then
                prvHandler(Me, Nothing)
            End If
        End If
    End Sub

    Public Sub setType(ByVal t As String)
        If Me.lblType.Text <> t Then
            changeLabel()
            If Me.lblType.Text <> t Then
                changeLabel()
            End If
        End If
    End Sub

    Private Sub lblType_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lblType.Click
        If prvProfID <> SHADE_ID Then
            changeLabel()
        End If
    End Sub

    Private Sub ihControl1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.cmbSymbSpirit.Top = 0
        Me.lblQL.Top = 0
        Me.lblAlienEye.Top = 0
    End Sub

    Private Sub nudQL_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nudQL.ValueChanged
        prvQL = Me.nudQL.Value
        updateTT()
        ' can be called during setup, so ensure index is valid
        If prvItemIdx <> -1 Then
            shopA(Me.prvItemIdx).clearAll()
            shopA(Me.prvItemIdx).setLabel(1, Me.ShinyCluster, Me.QL)
            shopA(Me.prvItemIdx).setLabel(2, Me.BrightCluster, Me.QL)
            shopA(Me.prvItemIdx).setLabel(3, Me.FadedCluster, Me.QL)
        End If
        If useHandler Then
            prvHandler(Me, e)
        End If
    End Sub

    Private Sub nudQL_Leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles nudQL.Leave
        If prvQL <> Me.nudQL.Value Then
            prvQL = Me.nudQL.Value
            updateTT()
            shopA(Me.prvItemIdx).clearAll()
            shopA(Me.prvItemIdx).setLabel(1, Me.ShinyCluster, Me.QL)
            shopA(Me.prvItemIdx).setLabel(2, Me.BrightCluster, Me.QL)
            shopA(Me.prvItemIdx).setLabel(3, Me.FadedCluster, Me.QL)
            If useHandler Then
                prvHandler(Me, e)
            End If
        End If
    End Sub

    Private Sub cmbSymbSpirit_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbSymbSpirit.SelectedIndexChanged
        Dim s As String
        Dim p As Integer
        Dim sk As String
        Dim ska() As String
        Dim skv As String
        Dim skk As String
        Dim sc As New SortedList
        Dim de As DictionaryEntry

        If Me.cmbSymbSpirit.SelectedIndex = 0 Then
            Me.lblQL.Text = ""
            Return
        End If
        s = Me.cmbSymbSpirit.Items(Me.cmbSymbSpirit.SelectedIndex)
        p = s.IndexOf("(QL")
        s = s.Substring(p + 3)
        s = s.Substring(0, s.Length - 1)
        Me.lblQL.Text = s
        If Me.SymbiantOrSpirit() <> SEL_STRING Then
            sk = Me.SymbSpiritBonuses()
            ska = sk.Split("#")
            For j As Integer = 0 To ska.Length - 1
                p = ska(j).IndexOf(" : ")
                skk = ska(j).Substring(0, p)
                skv = ska(j).Substring(p + 3)
                If sc.ContainsKey(skk) Then
                    sc(skk) = CStr(CInt(sc(skk)) + CInt(skv))
                Else
                    sc.Add(skk, skv)
                End If
            Next
            s = ""
            For Each de In sc
                If s <> "" Then
                    s &= Chr(10)
                End If
                s &= de.Key & " : " & de.Value
            Next
            Me.ttHover.SetToolTip(Me.cmbSymbSpirit, s)
        Else
            Me.ttHover.SetToolTip(Me.cmbSymbSpirit, Nothing)
        End If
        If useHandler Then
            prvHandler(Me, e)
        End If
    End Sub

    Private Sub cmbShiny_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbShiny.SelectedIndexChanged
        updateTT()
        shopA(Me.prvItemIdx).clearOne(1)
        shopA(Me.prvItemIdx).setLabel(1, Me.ShinyCluster, Me.QL)
        If useHandler Then
            prvHandler(Me, e)
        End If
    End Sub

    Private Sub cmbBright_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbBright.SelectedIndexChanged
        updateTT()
        shopA(Me.prvItemIdx).clearOne(2)
        shopA(Me.prvItemIdx).setLabel(2, Me.BrightCluster, Me.QL)
        If useHandler Then
            prvHandler(Me, e)
        End If
    End Sub

    Private Sub cmbFaded_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbFaded.SelectedIndexChanged
        updateTT()
        shopA(Me.prvItemIdx).clearOne(3)
        shopA(Me.prvItemIdx).setLabel(3, Me.FadedCluster, Me.QL)
        If useHandler Then
            prvHandler(Me, e)
        End If
    End Sub

    Private Sub updateTT()
        Dim s As String = ""
        Dim i As Integer

        If Me.ShinyCluster <> SEL_STRING Then
            s &= Me.ShinyCluster & " : " & CStr(Me.ShinyClusterBonus)
        End If
        If Me.BrightCluster <> SEL_STRING Then
            If s <> "" Then
                s &= Chr(10)
            End If
            s &= Me.BrightCluster & " : " & CStr(Me.BrightClusterBonus)
        End If
        If Me.FadedCluster <> SEL_STRING Then
            If s <> "" Then
                s &= Chr(10)
            End If
            s &= Me.FadedCluster & " : " & CStr(Me.FadedClusterBonus)
        End If
        If s <> "" Then
            Me.ttHover.SetToolTip(Me.cmbShiny, s)
            Me.ttHover.SetToolTip(Me.cmbBright, s)
            Me.ttHover.SetToolTip(Me.cmbFaded, s)
        Else
            Me.ttHover.SetToolTip(Me.cmbShiny, Nothing)
            Me.ttHover.SetToolTip(Me.cmbBright, Nothing)
            Me.ttHover.SetToolTip(Me.cmbFaded, Nothing)
        End If
        ' update attribute label here...
        If Me.SorI = "I" Then
            s = getImplantReqs(Me.ShinyCluster, Me.BrightCluster, Me.FadedCluster, 1)
            If s = "" Then
                Me.lblAttrib.Text = "None"
            ElseIf s = "ERROR" Then
                Me.lblAttrib.Text = "Error"
            Else
                s = s.Split("|")(1)
                For i = 0 To 5
                    If abilityFull(i) = s Then
                        s = abilityAbrev(i)
                    End If
                Next
                If s.Length <> 3 Then
                    s = "???"
                End If
                Me.lblAttrib.Text = s
            End If
        ElseIf Me.SorI = "A" Then
            Me.ttHover.SetToolTip(Me.lblAlienEye, getAlienEyeTooltip(Me.prvQL))
        End If
    End Sub

End Class
